/*
 ============================================================================
 Name        : C_SharedMemory.c
 Author      : 
 Version     :
 Copyright   : Your copyright notice
 Description : Hello World in C, Ansi-style
 ============================================================================
 */

//#include <stdio.h>
//#include <stdlib.h>

//int main(void) {
//	puts("!!!Hello World!!!"); /* prints !!!Hello World!!! */
//	return EXIT_SUCCESS;
//}

#include "ThereminoSlots.h"

#include <fcntl.h>
#include <sys/stat.h>
#include <errno.h>
#include <sys/mman.h>
#include <sys/types.h> //shm_open
#include <stdio.h>  //printf
#include <stdlib.h> //exit
#include <unistd.h> //close
#include <string.h> //strerror

/* This will be created under /dev/shm/ */
#define STATE_FILE "/theremino1.shared"
#define  NAMESIZE 1024
#define   MAXNAMES 100

/* Define a struct we wish to share. Notice that we will allocate
 * only sizeof SHARED_VAR, so all sizes are constant
 */
typedef struct
{
  char name[MAXNAMES][NAMESIZE];
  int flags;
  float slots[1000];
}  SHARED_VAR;

int main (void)
{
int first = 0;
int result = 0;
int shm_fd;
static SHARED_VAR *conf;

///////////////////

int res;
float myval = 0.0F;

if (1)
{
	res = the_slot_init();
	printf("Value of init = %d\n", res);

	the_slot_write(10, 5.678F);
	myval = the_slot_read(10);
	printf("Value of slots[321] = %f\n", myval);



	res = the_slot_exit();
	exit(0);

}

///////////////////







  /* Try to open the shm instance with  O_EXCL,
   * this tests if the shm is already opened by someone else
   */
  if((shm_fd = shm_open(STATE_FILE, (O_CREAT | O_EXCL | O_RDWR),
                       (S_IREAD | S_IWRITE))) > 0 ) {
          first = 1; /* We are the first instance */
  }
  else if((shm_fd = shm_open(STATE_FILE, (O_CREAT | O_RDWR),
                        (S_IREAD | S_IWRITE))) < 0) {
   /* Try to open the shm instance normally and share it with
    * existing clients
    */
    printf("Could not create shm object. %s\n", strerror(errno));
    return errno;
  }

  /* Set the size of the SHM to be the size of the struct. */
  result = ftruncate(shm_fd, sizeof(SHARED_VAR));

  /* Connect the conf pointer to set to the shared memory area,
   * with desired permissions
   */
  if((conf =  mmap(0, sizeof(SHARED_VAR), (PROT_READ | PROT_WRITE),
                   MAP_SHARED, shm_fd, 0)) == MAP_FAILED) {

    return errno;

  }
  if(first) {
   /* Run a set up for the first time, fill some args */
   printf("First creation of the shm. Setting up default values\n");
   conf->flags = 4;
   conf->slots[123] = -456.7F;
  }
  else
  {
    printf("Value of flags = %d\n", conf->flags);
    printf("Value of slots[123] = %f\n", conf->slots[123]);
  }

/* Do some work... */

  close(shm_fd);

  int n;
  printf ("Hit any key to terminate");
  result = scanf ("%d",&n);

  exit(0);
}

